﻿Imports System.Collections.ObjectModel
Imports PageLayoutControl.CustomPrinterLayerShapeStyle
Imports PageLayoutControl.PrinterLayerDrawingUtilities
Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles

Public Class CustomPrinterDrawingLayerStyle
  Inherits AreaStyle
  Public Property DrawingShape As BaseShape
  Public LineDrawingStyle As LineStyle
  Public AreaDrawingStyle As AreaStyle
  Public DrawingType As EnumPrinterLayerDrawingType
  Public Sub New(oDrawingShape As BaseShape, eDrawingType As EnumPrinterLayerDrawingType)
    MyBase.New
    DrawingType = eDrawingType
    DrawingShape = oDrawingShape
    LineDrawingStyle = LineStyles.CreateSimpleLineStyle(GeoColors.Red, 2, True)
    AreaDrawingStyle = AreaStyles.CreateSimpleAreaStyle(GeoColors.Transparent, GeoColors.Black, 2)
  End Sub
  Protected Overrides Sub DrawCore(features As IEnumerable(Of Feature), canvas As GeoCanvas, labelsInThisLayer As Collection(Of SimpleCandidate), labelsInAllLayers As Collection(Of SimpleCandidate))
    Dim oShapeToDraw As New Collection(Of BaseShape) From {DrawingShape}
    Dim oCurrentExtent As RectangleShape = features(0).GetShape.GetBoundingBox
    Dim oShapeExtent As RectangleShape = DrawingShape.GetBoundingBox
    Dim dX As Double = oCurrentExtent.UpperRightPoint.X - oShapeExtent.UpperRightPoint.X
    Dim dY As Double = oCurrentExtent.UpperRightPoint.Y - oShapeExtent.UpperRightPoint.Y
    DrawingShape.TranslateByOffset(dX, dY)
    DrawingShape.ScaleTo(oCurrentExtent.Width / oShapeExtent.Width)
    Select Case DrawingType
      Case EnumPrinterLayerDrawingType.Line
        LineDrawingStyle.Draw(oShapeToDraw, canvas, labelsInAllLayers, labelsInAllLayers)
      Case EnumPrinterLayerDrawingType.Polygon, EnumPrinterLayerDrawingType.Ellipse
        AreaDrawingStyle.Draw(oShapeToDraw, canvas, labelsInAllLayers, labelsInAllLayers)
    End Select



    'MyBase.DrawCore(features, canvas, labelsInThisLayer, labelsInAllLayers)
  End Sub
End Class
