﻿Imports PageLayoutControl.PrinterLayerDrawingUtilities
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.WinForms

Public Class Form1
  Private msShapeFilePath As String = "..\..\Data\LMI Org 149.shp"
  Private moShapeFile As ShapeFileFeatureLayer
  Private moMapPrinterLayer As New MapPrinterLayer
  Private moAdornmentOverlay As AdornmentOverlay
  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    Me.WindowState = FormWindowState.Maximized

    Dim oCurrentExtent As RectangleShape = PageLayout.PrinterPage.GetBoundingBox
    oCurrentExtent.ScaleUp(10)
    PageLayout.CurrentExtent = oCurrentExtent
    mLoadShapefile()

    moAdornmentOverlay = New AdornmentOverlay()
    'moAdornmentOverlay.

    PageLayout.Refresh()
  End Sub
  Private Sub mLoadShapefile()
    moShapeFile = New ShapeFileFeatureLayer(msShapeFilePath, GeoFileReadWriteMode.Read)
    moShapeFile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColors.Transparent, GeoColors.Blue, 1)
    moShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

    Dim oProj4 As New Proj4Projection
    With oProj4
      .InternalProjectionParametersString = Proj4Projection.GetEsriParametersString(102003)
      .ExternalProjectionParametersString = Proj4Projection.GetEsriParametersString(26916)
    End With
    oProj4.Open()
    moShapeFile.FeatureSource.Projection = oProj4

    moShapeFile.Open()

    PageLayout.PageLayoutMap.Layers.Add(moShapeFile)
    PageLayout.PageLayoutMap.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter

    Dim oFeatures = moShapeFile.QueryTools.GetFeaturesByColumnValue("ShapeKey", "10382", ReturningColumnsType.NoColumns)

    'PageLayout.PageLayoutMap.MapExtent = oFeatures(0).GetBoundingBox
    PageLayout.PageLayoutMap.MapExtent = ExtentHelper.GetDrawingExtent(oFeatures(0).GetBoundingBox, CSng(PageLayout.PageLayoutMap.GetBoundingBox().Width), CSng(PageLayout.PageLayoutMap.GetBoundingBox().Height))
    PageLayout.PageLayoutMap.SelectabilityMode = SelectabilityMode.NonSelectable
    PageLayout.ExtentOverlay.DoubleLeftClickMode = ThinkGeo.MapSuite.WinForms.MapDoubleLeftClickMode.Disabled
    PageLayout.ExtentOverlay.DoubleRightClickMode = ThinkGeo.MapSuite.WinForms.MapDoubleRightClickMode.Disabled
    PageLayout.ExtentOverlay.PanMode = ThinkGeo.MapSuite.WinForms.MapPanMode.Disabled
    PageLayout.ExtentOverlay.MouseWheelMode = ThinkGeo.MapSuite.WinForms.MapMouseWheelMode.Disabled

    Dim oInMemoryFeatureLayer As New InMemoryFeatureLayer
    With oInMemoryFeatureLayer.ZoomLevelSet
      .ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColors.Red, 20, GeoColors.Black)
      .ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
    End With
    PageLayout.PageLayoutMap.Layers.Add(oInMemoryFeatureLayer)

    PageLayout.InMemDisplayLayer = oInMemoryFeatureLayer

    'PageLayout.Overlays.Add(oOverlay)
  End Sub
  Private Sub Button1_Click(sender As Object, e As EventArgs)
    PageLayout.StartDrawing(EnumPrinterLayerDrawingType.Arrow)
  End Sub

  Private Sub btnDrawShape_Click(sender As Object, e As EventArgs)
    PageLayout.StartDrawing(EnumPrinterLayerDrawingType.Line)
  End Sub

  Private Sub btnDrawEllipse_Click(sender As Object, e As EventArgs)
    PageLayout.StartDrawing(EnumPrinterLayerDrawingType.Ellipse)
  End Sub

End Class
